/**
 * Copyright (c) 2009 Jeremy Stribling, Yair Sovran, Irene Zhang, 
 *                    Xavid Pretzer, Jinyang Li, Frans Kaashoek, Robert Morris,
 *     		      Massachusetts Institute of Technology,
 * 		      New York University
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


#ifndef __NODE_MANAGER_CENT_H__
#define __NODE_MANAGER_CENT_H__ 1

#include <rpc.h>
#include "node_manager.h"
#include <vivaldi.h>
#include <wfs_client_manager.h>

class node_manager_cent : public node_manager {

 private:
  wfs_node _me;
  sockaddr_in _cserver;
  wfs_node _cserver_node;
  vivaldi *_viv;
  wfs_client_manager *_clients;
  int _ping_period;

 public:

  node_manager_cent( wfs_node me, sockaddr_in cserver, 
		     int ping_period = 10, 
		     vivaldi *v = NULL, wfs_client_manager *clients = NULL );
  ~node_manager_cent();
  void loop();

};

#endif // __NODE_MANAGER_CENT_H__
