/**
 * Copyright (c) 2009 Jeremy Stribling, Yair Sovran, Irene Zhang, 
 *                    Xavid Pretzer, Jinyang Li, Frans Kaashoek, Robert Morris,
 *     		      Massachusetts Institute of Technology,
 * 		      New York University
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


#ifndef rsm_log_h
#define rsm_log_h

#include <stdio.h>

#include "rsm_protocol.h"

class rsm_log {
	public:

  rsm_log(std::string s, std::string log_dir);
	~rsm_log(); 

	void save_request(const rsm_record &r, bool sync = true);
	bool load_request(const viewstamp &vs, rsm_record &r);

  bool do_checkpoint();
	void save_checkpoint(const rsm_record &r);
	bool load_checkpoint(rsm_record &r);

	void reset_read();
	void reset_write();

  viewstamp last_cp() { return last_cp_vs;}

	private:
	bool read_record(int fd, rsm_record &r);
	void write_record(int fd, const rsm_record &r, bool sync = true);
	std::string lname;
	std::string cname;
	int rfd;
	int wfd;
	unsigned long total;
  viewstamp last_cp_vs;

};
#endif
